<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FutureRatesCurrencyExchangeRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FutureRatesCurrencyExchangeRate extends AbstractStructArrayBase
{
    /**
     * The CurrencyExchangeRates
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FutureRatesCurrencyExchangeRate[]
     */
    public $CurrencyExchangeRates;
    /**
     * Constructor method for ArrayOfJP_FutureRatesCurrencyExchangeRate
     * @uses ArrayOfJP_FutureRatesCurrencyExchangeRate::setCurrencyExchangeRates()
     * @param \StructType\JP_FutureRatesCurrencyExchangeRate[] $currencyExchangeRates
     */
    public function __construct(array $currencyExchangeRates = array())
    {
        $this
            ->setCurrencyExchangeRates($currencyExchangeRates);
    }
    /**
     * Get CurrencyExchangeRates value
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate[]|null
     */
    public function getCurrencyExchangeRates()
    {
        return $this->CurrencyExchangeRates;
    }
    /**
     * This method is responsible for validating the values passed to the setCurrencyExchangeRates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCurrencyExchangeRates method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCurrencyExchangeRatesForArrayConstraintsFromSetCurrencyExchangeRates(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem instanceof \StructType\JP_FutureRatesCurrencyExchangeRate) {
                $invalidValues[] = is_object($arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem) ? get_class($arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem) : sprintf('%s(%s)', gettype($arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem), var_export($arrayOfJP_FutureRatesCurrencyExchangeRateCurrencyExchangeRatesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CurrencyExchangeRates property can only contain items of type \StructType\JP_FutureRatesCurrencyExchangeRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CurrencyExchangeRates value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FutureRatesCurrencyExchangeRate[] $currencyExchangeRates
     * @return \ArrayType\ArrayOfJP_FutureRatesCurrencyExchangeRate
     */
    public function setCurrencyExchangeRates(array $currencyExchangeRates = array())
    {
        // validation for constraint: array
        if ('' !== ($currencyExchangeRatesArrayErrorMessage = self::validateCurrencyExchangeRatesForArrayConstraintsFromSetCurrencyExchangeRates($currencyExchangeRates))) {
            throw new \InvalidArgumentException($currencyExchangeRatesArrayErrorMessage, __LINE__);
        }
        $this->CurrencyExchangeRates = $currencyExchangeRates;
        return $this;
    }
    /**
     * Add item to CurrencyExchangeRates value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FutureRatesCurrencyExchangeRate $item
     * @return \ArrayType\ArrayOfJP_FutureRatesCurrencyExchangeRate
     */
    public function addToCurrencyExchangeRates(\StructType\JP_FutureRatesCurrencyExchangeRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FutureRatesCurrencyExchangeRate) {
            throw new \InvalidArgumentException(sprintf('The CurrencyExchangeRates property can only contain items of type \StructType\JP_FutureRatesCurrencyExchangeRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CurrencyExchangeRates[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FutureRatesCurrencyExchangeRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CurrencyExchangeRates
     */
    public function getAttributeName()
    {
        return 'CurrencyExchangeRates';
    }
}
